
/**
 * ^Cg:     Noiz<p>
 * :         <p>
 * 쌠:       Copyright (c) Kenta Cho(ABA."Saba")<p>
 * Ж:       ABA Games<p>
 * @author Kenta Cho(ABA."Saba")
 * @version 1.0
 */
package jp.gr.java_conf.abagames.noiz;

import java.applet.Applet;
import java.awt.*;

/**
 * Noiz applet main routine
 */
public class Noiz extends Applet {

  private Screen screen;
  private GameManager gameManager;

  private final String HALF_FR_PARAM = "HALF_FRAMERATE";
  private final String NO_BG_PARAM = "NO_BACKGROUND";

  public void init() {
  }

  public static final int SCREEN_WIDTH = 320;
  public static final int SCREEN_HEIGHT = 320;

  private void restartGame() {
    if ( gameManager != null ) {
      gameManager.restart();
      gameManager = null;
      screen = null;
    }
  }

  public void start() {
    restartGame();
    screen = new Screen();
    gameManager = new GameManager();
    repaint();
  }

  public void stop() {
    restartGame();
  }

  public void destroy() {
    restartGame();
  }

  private boolean firstRepaint = true;

  public void paint(Graphics g) {
    if ( screen != null ) {
      screen.makeBuffer(this);
      if ( gameManager != null && firstRepaint ) {
        firstRepaint = false;
        gameManager.init(this, screen);
        String hfPrm = getParameter(HALF_FR_PARAM);
        if ( hfPrm != null && hfPrm.equals("true") ) {
          gameManager.setHalfFrameRate(true);
        }
        String nbPrm = getParameter(NO_BG_PARAM);
        if ( nbPrm != null && nbPrm.equals("true") ) {
          screen.setNoBackGround(true);
        }
        gameManager.start();
      }
    }
  }

  public void update(Graphics g) {
    paint(g);
  }


  public boolean handleEvent(Event event) {
    if ( gameManager!=null
     && event.target==this && event.id==event.MOUSE_MOVE ) {
      gameManager.setMousePos(event.x, event.y);
      return true;
    } else {
      return super.handleEvent(event);
    }
  }

  public static void main(String[] args) {
    Noiz noiz = new Noiz();
    noiz.init();
    noiz.start();
  }
}
