
/**
 * ^Cg:     Noiz<p>
 * :         <p>
 * 쌠:       Copyright (c) Kenta Cho(ABA."Saba")<p>
 * Ж:       ABA Games<p>
 * @author Kenta Cho(ABA."Saba")
 * @version 1.0
 */
package jp.gr.java_conf.abagames.noiz;

import jp.gr.java_conf.abagames.noiz.texturemaker.*;

import java.awt.*;
import java.awt.image.*;
import java.applet.Applet;
import java.util.Random;

/**
 * draw applet screen
 */
public class Screen {
  private int pbuf[], bpbuf[];
  private int pbuf1[], pbuf2[];
  private boolean p1Face;
  private int bufBldIdx[];
  private MemoryImageSource imageSource;
  private Image bufImage;

  private int screenToTnlTex[];
  private final int TNLTEX_WIDTH = TextureMaker.TNLTEX_WIDTH;
  private final int TNLTEX_HEIGHT = TextureMaker.TNLTEX_HEIGHT;

  private final int SCREEN_HEIGHT = Noiz.SCREEN_HEIGHT;
  private final int SCREEN_WIDTH = Noiz.SCREEN_WIDTH;

  private Random rnd = new Random();

  private boolean noBackGround = false;

  public void setNoBackGround(boolean f) {
    noBackGround = f;
  }

  private boolean halfFrameRate = false;

  public void setHalfFrameRate(boolean f) {
    halfFrameRate = f;
  }

  public Screen() {
    pbuf1 = new int[Noiz.SCREEN_WIDTH * Noiz.SCREEN_HEIGHT+1];
    pbuf2 = new int[Noiz.SCREEN_WIDTH * Noiz.SCREEN_HEIGHT+1];
    pbuf = pbuf1; bpbuf = pbuf2; p1Face = true;

    pbuf1[pbuf1.length-1] = pbuf2[pbuf2.length-1] = 0;
    bufBldIdx = new int[Noiz.SCREEN_WIDTH*Noiz.SCREEN_HEIGHT];
    for ( int i = Noiz.SCREEN_WIDTH*Noiz.SCREEN_HEIGHT-1 ; i>=0 ; i-- ){
      int y = i/Noiz.SCREEN_WIDTH;
      int x = i-y*Noiz.SCREEN_HEIGHT;
      x -= Noiz.SCREEN_WIDTH/2; y -= Noiz.SCREEN_HEIGHT/2;
      //x *= 0.95f; y *= 0.95f;
      //x *= 1.05f; y *= 1.05f;
      //x += (rnd.nextInt()%5);
      //y += (rnd.nextInt()%5);
      x += Math.sin(3.14*0.05*x)/150;
      y += Math.sin(3.14*0.05*y)/150;
      x += Noiz.SCREEN_WIDTH/2; y += Noiz.SCREEN_HEIGHT/2;
      if ( x>=0 && x<Noiz.SCREEN_WIDTH && y>=0 && y<Noiz.SCREEN_HEIGHT ) {
        bufBldIdx[i] = x+y*Noiz.SCREEN_WIDTH;
      } else {
        bufBldIdx[i] = pbuf1.length-1;
      }
    }
    screenToTnlTex = new int[Noiz.SCREEN_WIDTH * Noiz.SCREEN_HEIGHT];
    int idx = 0;
    for ( int y=-Noiz.SCREEN_HEIGHT/2 ; y<Noiz.SCREEN_HEIGHT/2 ; y++ ) {
      for ( int x=-Noiz.SCREEN_WIDTH/2 ; x<Noiz.SCREEN_WIDTH/2 ; x++ ) {
        int tx =
          (int)(Math.atan2(x, y)*TNLTEX_WIDTH*2/Math.PI)%TNLTEX_WIDTH;
        while ( tx < 0 ) tx += TNLTEX_WIDTH;
        int ty = (int)((double)7680/Math.sqrt(x*x+y*y))%TNLTEX_HEIGHT;
        if ( ty < 0 ) ty = 0;
        screenToTnlTex[idx] = tx+ty*TNLTEX_WIDTH;
        idx++;
      }
    }
    initTexture();
    initLevelMissLetters();
  }

  /**
   * make screen buffer(off screen image)
   */
  public void makeBuffer(Component cmp) {
    imageSource = new MemoryImageSource
      (Noiz.SCREEN_WIDTH, Noiz.SCREEN_HEIGHT, pbuf, 0, Noiz.SCREEN_WIDTH);
    imageSource.setAnimated(true);
    //imageSource.setFullBufferUpdates(true);
    bufImage = cmp.createImage(imageSource);
    grp = cmp.getGraphics();
  }

  private TextureMaker[][] textureType = new TextureMaker[3][];
  private TextureMaker[] textureMaker = new TextureMaker[3];

  public Letters letters;

  /**
   * init tunnel texture pattern
   */
  private void initTexture() {
    textureType[0] = new TextureMaker[1];
    textureType[0][0] = letters = new Letters();
    textureType[1] = new TextureMaker[1];
    textureType[1][0] = new Grid();
    textureType[2] = new TextureMaker[1];
    textureType[2][0] = new Dots();
    for ( int i=textureMaker.length-1; i>=0 ; i-- ) {
      textureMaker[i] = textureType[i][0];
      textureMaker[i].clear();
      textureMaker[i].start();
    }
  }

  public void setTunnelTexture() {
    for ( int i=textureMaker.length-1; i>=0 ; i-- ) {
      if ( !(textureMaker[i].draw(halfFrameRate)) ) {
        textureMaker[i].clear();
        textureMaker[i] = textureType[i]
          [Math.abs(rnd.nextInt()%textureType[i].length)];
        textureMaker[i].start();
      }
    }
  }

  private int tunnelX = 0, tunnelY = 0;
  private final int TNLTEX_SIZE = TNLTEX_WIDTH*TNLTEX_HEIGHT;

  /**
   * clear screen and make smoke effect
   */
  public final void clear() {
    if ( noBackGround ) {
      for ( int i=pbuf.length-2 ; i>=0 ; i-- ){
        pbuf[i] = 0xff000000;
      }
    } else {

    System.arraycopy(pbuf, 0, bpbuf, 0, bufBldIdx.length);
    int tnlOfs = tunnelY*TNLTEX_WIDTH+tunnelX;
    for ( int i=bufBldIdx.length-1 ; i>=0 ; i-- ){
      int px = bpbuf[bufBldIdx[i]];
      int r = (((px&0xff0000)>>8 ) * 200)&0xff0000;
      int g = (((px&0x00ff00)>>8 ) * 160)&0x00ff00;
      int b =  ((px&0x0000ff)    ) * 240 >> 8;
      int ttIdx =
        (screenToTnlTex[i]+tnlOfs)%TNLTEX_SIZE;
      pbuf[i] =
        textureMaker[0].texture[ttIdx] |
        textureMaker[1].texture[ttIdx] |
        textureMaker[2].texture[ttIdx] |
        r | g | b;
    }
    if ( halfFrameRate ) {
      tunnelX += 2; tunnelY += 2;
    } else {
      tunnelX++; tunnelY++;
    }
    if ( tunnelX >= TNLTEX_WIDTH ) tunnelX -= TNLTEX_WIDTH;
    setTunnelTexture();

    }
  }

  // draw level and miss count

  private Letters levelLetters, missLetters;

  private void initLevelMissLetters() {
    levelLetters = new Letters();
    missLetters = new Letters();
  }

  private void drawTexture
   (TextureMaker texture, int ofx, int ofy, int width, int height) {
    int[] txt = texture.texture;
    for ( int y=0 ; y<height ; y++ ) {
      int scIdx = ofx + (ofy-y)*SCREEN_WIDTH;
      int txIdx = y*texture.TNLTEX_WIDTH;
      for ( int x=0 ; x<width ; x++, scIdx++, txIdx++ ) {
        pbuf[scIdx] |= txt[txIdx];
      }
    }
  }

  public final void drawLevelMissLetters() {
    drawTexture(levelLetters, 0, 20, 80, 20);
    drawTexture(missLetters, 240, 20, 80, 20);
  }

  private final int LVL_COLOR = 0xffff66;

  public final void setLevelTexture(int level) {
    levelLetters.clear();
    levelLetters.addLetter(10 + 'L'-'A', 5, 10, 6, LVL_COLOR);
    levelLetters.addLetter(10 + 'V'-'A', 15, 10, 6, LVL_COLOR);
    levelLetters.addLetter(10 + 'L'-'A', 25, 10, 6, LVL_COLOR);
    int x = 65;
    for ( int i=0 ; i<3 ; i++ ) {
      levelLetters.addLetter(level%10, x, 10, 6, 0xffffff);
      level /= 10;
      if ( level <= 0 ) break;
      x -= 10;
    }
  }

  private final int MISS_COLOR = 0xff7777;

  public final void setMissTexture(int miss) {
    missLetters.clear();
    missLetters.addLetter(10 + 'M'-'A', 40, 10, 6, MISS_COLOR);
    missLetters.addLetter(10 + 'I'-'A', 50, 10, 6, MISS_COLOR);
    missLetters.addLetter(10 + 'S'-'A', 60, 10, 6, MISS_COLOR);
    missLetters.addLetter(10 + 'S'-'A', 70, 10, 6, MISS_COLOR);
    int x = 20;
    for ( int i=0 ; i<3 ; i++ ) {
      missLetters.addLetter(miss%10, x, 10, 6, 0xffffff);
      miss /= 10;
      if ( miss <= 0 ) break;
      x -= 10;
    }
  }

  private ColorModel colorModel = ColorModel.getRGBdefault();
  private Graphics grp;

  public final void swap() {
    imageSource.newPixels();
    grp.drawImage(bufImage, 0, 0, null);
  }

  private final int alphaBlend(int a, int b, int rate) {
    int tmp;
    tmp = (b & 0xff0000)>>16;
    int red = ((((a & 0xff0000)>>16) - tmp) * rate >>16) + tmp;
    tmp = (b & 0x00ff00)>>8;
    int green = ((((a & 0x00ff00)>>8 ) - tmp) * rate >>16) + tmp;
    tmp = (b & 0x0000ff);
    int blue = ((((a & 0x0000ff)    ) - tmp) * rate >>16) + tmp;
    return (red<<16) | (green<<8) | blue | 0xff000000;
  }

  /**
   * draw alpha blended line
   */
  public final void drawLine(int x1, int y1, int x2, int y2, int color) {
    try {

    x1 <<= 1; y1 <<= 1;
    x2 <<= 1; y2 <<= 1;
    if ( x1 < 0 ) {
      if ( x1 == x2 ) return;
      y1 = (y1-y2)*x2/(x2-x1)+y2;
      x1 = 0;
    } else if ( x2 < 0 ) {
      if ( x1 == x2 ) return;
      y2 = (y2-y1)*x1/(x1-x2)+y1;
      x2 = 0;
    }
    if ( x1 >= SCREEN_WIDTH ) {
      if ( x1 == x2 ) return;
      y1 = (y1-y2)*(x2-SCREEN_WIDTH)/(x2-x1)+y2;
      x1 = SCREEN_WIDTH-1;
    } else if ( x2 >= SCREEN_WIDTH ) {
      if ( x1 == x2 ) return;
      y2 = (y2-y1)*(x1-SCREEN_WIDTH)/(x1-x2)+y1;
      x2 = SCREEN_HEIGHT-1;
    }
    if ( y1 < 1 ) {
      if ( y1 == y2 ) return;
      x1 = (x1-x2)*(y2-1)/(y2-y1)+x2;
      y1 = 1;
    } else if ( y2 < 1 ) {
      if ( y1 == y2 ) return;
      x2 = (x2-x1)*(y1-1)/(y1-y2)+x1;
      y2 = 1;
    }
    if ( y1 > SCREEN_HEIGHT-2 ) {
      if ( y1 == y2 ) return;
      x1 = (x1-x2)*(y2-(SCREEN_HEIGHT-2))/(y2-y1)+x2;
      y1 = SCREEN_HEIGHT-2;
    } else if ( y2 > SCREEN_HEIGHT-2 ) {
      if ( y1 == y2 ) return;
      x2 = (x2-x1)*(y1-(SCREEN_HEIGHT-2))/(y1-y2)+x1;
      y2 = SCREEN_HEIGHT-2;
    }

    int lx = Math.abs(x2 - x1);
    int ly = Math.abs(y2 - y1);

    if ( lx < ly ) {
      if ( ly == 0 ) ly++;
      int ax = ((x2 - x1)<<16) / ly;
      int ay = ((y2 - y1)>>16) | 1;
      int x  = x1<<16;
      int y  = y1;
      for ( int i=ly-1 ; i>=0 ; i--, x+=ax, y+=ay ){
        int px = x>>16;
        int p1 = y * Noiz.SCREEN_WIDTH + px;
        //pbuf[p1] = color;
        int p2 = p1 + 1;
        int rx = x & 0xffff;
        pbuf[p1] = alphaBlend(pbuf[p1],color,       rx);
        pbuf[p2] = alphaBlend(pbuf[p2],color,0xffff-rx);
      }
    } else {
      if ( lx == 0 ) lx++;
      int ay = ((y2 - y1)<<16) / lx;
      int ax = ((x2 - x1)>>16) | 1;
      int x  = x1;
      int y  = y1<<16;
      for ( int i=lx-1 ; i>0 ; i--, x+=ax, y+=ay ) {
        int py = y>>16;
        int p1 = py * Noiz.SCREEN_WIDTH + x;
        //pbuf[p1] = color;
        int p2 = p1 + Noiz.SCREEN_WIDTH;
        int ry = y & 0xffff;
        pbuf[p1] = alphaBlend(pbuf[p1],color,       ry);
        pbuf[p2] = alphaBlend(pbuf[p2],color,0xffff-ry);
      }
    }

    } catch ( ArrayIndexOutOfBoundsException e ) {}
  }

}
