
/**
 * ^Cg:     Noiz<p>
 * :         <p>
 * 쌠:       Copyright (c) Kenta Cho(ABA."Saba")<p>
 * Ж:       ABA Games<p>
 * @author Kenta Cho(ABA."Saba")
 * @version 1.0
 */
package jp.gr.java_conf.abagames.noiz.curtainmaker;

import jp.gr.java_conf.abagames.noiz.*;
import jp.gr.java_conf.abagames.util.*;
import java.util.Random;

/**
 * abstract class for bullet curtain makers
 */
public abstract class CurtainMaker {
  public final int maxRank;

  public abstract void make(int rank);

  public CurtainMaker(Bullet[] bullet, int maxRank) {
    this.bullet = bullet;
    this.maxRank = maxRank;
  }

  private static Random rnd = new Random();

  protected int randN(int n) {
    return Math.abs(rnd.nextInt())%n;
  }

  protected final int getDeg(int x, int y) {
    return DegUtil.getDeg(x, y);
  }

  protected final boolean TRUE = true;
  protected final boolean FALSE = false;

  protected final int[] sintbl = SCTable.sintbl;
  protected final int[] costbl = SCTable.costbl;

  public static int xp, yp;

public static final int CTTYPE_MAX = 12;

public static final int BULLET_MAX = 128;
private static int bulletIdx = BULLET_MAX - 1;

private Bullet[] bullet;
public static final int BULLET_NOT_EXIST = -9999;

public static int timer;

public Bullet nextBullet() {
  Bullet bl;
  if ( bullet[bulletIdx].point0.mx != BULLET_NOT_EXIST ) {
    int i;
    for ( i=0 ; i<bullet.length ; i++ ) {
      bulletIdx--; if ( bulletIdx < 0 ) bulletIdx += bullet.length;
      if ( bullet[bulletIdx].point0.mx == BULLET_NOT_EXIST ) break;
    }
    if ( i == bullet.length ) return null;
  }
  bl = bullet[bulletIdx];
  bulletIdx--; if ( bulletIdx < 0 ) bulletIdx += bullet.length;
  return bl;
}

}
